(ns ludus.error
 	(:require [clojure.string :as string]))

(defn get-line [source line]
 	(let [lines (string/split-lines source)
     			the_line (nth lines (dec line))]
 			the_line))

(string/split-lines "abcd")

(defn get-underline [source {:keys [line start lexeme]} prefix]
 	(let [lines (string/split-lines source)
      		lines-before (subvec lines 0 (dec line))
      		line-start (reduce (fn [len line] (+ len (count line))) (count lines-before) lines-before)
      		from-start (- start line-start)
      		underline-length (count lexeme)
      		padding (string/join (take (+ prefix from-start) (repeat "-")))
      		underline (string/join (take underline-length (repeat "^")))]
  		(apply str padding underline)
  		))

(defn scan-error [] :TODO)

(defn parse-error [{:keys [trace token]}]
 	(let [source (:source token)
     			input (:input token)
     			line-num (:line token)
     			line (get-line source line-num)
      		line-num (:line token)
      		prefix (str line-num ": ")
      		underline (get-underline source token (count prefix))
      		expected (first trace)
      		got (:type token)
      		message (str "Ludus found a parsing error on line " line-num " in " input ".\nExpected: " expected "\nGot: " got "\n")
      		]
  		(str message "\n" prefix line "\n" underline)
  		)
 	)

(defn run-error [{:keys [message token line]}]
 	(let [source (:source token) input (:input token)]
   	(if line
    		(str "Ludus panicked!: " message "\nOn line " line " in " input "\n" (get-line source line))
    		(str "Ludus panicked!\n" message)
    		)))

